#!/bin/bash

PROCESS=dtm-daemon.py
MANAGE=dtm-admin.py
ARG='--config=../ini/dtm-admin.ini --cmd=STOP'
LOGDIR='../log/'
LOG=$(basename $0).log
COUNTER=0

RED='\e[1;31m'
BLUE='\e[1;34m'
DEF='\e[0m'

DELAY=5
MAXITERATION=300

function checkQueue() {
    # $1 - param
    CHECKQUEUE=$(./dtm-daemon_tasks.sh "$1")
    if [[ $CHECKQUEUE == 0 ]]
    then
        echo "FINISHED"
    else
        echo $CHECKQUEUE
    fi
}

### Check process (worked or not) and stop, if worked ###
if [ $(pgrep $PROCESS) ]
then
    if [[ "$1" != "-force" && "$1" != "--force" ]]
    then
        echo "Max iteration "$MAXITERATION", delay between iteration "$DELAY" seconds, estimated time for run script about "$(($MAXITERATION*$DELAY))" seconds, or "$(($MAXITERATION*$DELAY/60))" minutes"
        while :
        do
            echo -e $BLUE'Start iteration '$COUNTER $DEF
            # CHECK COUNT < 300 ITERATION #
            if [[ $COUNTER -ge $MAXITERATION ]]
            then
                echo -e $RED'End iteration '$COUNTER': maximum iteration'$DEF
                echo -e $RED'Service ['$PROCESS'] not stopped, bacause queues not empty'$DEF
                exit 1
            fi
            # CHECK STATUS #
            #echo -e $BLUE"Check dtm-daemon queue"$DEF
            CHECK=$(checkQueue "size")
            if [[ $CHECK == "FINISHED" ]]
            then
                echo -e $RED'End iteration '$COUNTER': all queues empty'$DEF
                break
            else
                echo -e $RED'Iteration '$COUNTER' - not empty, queue for end: '$CHECK $DEF
            fi
            sleep $DELAY
            echo -e $BLUE'End iteration '$COUNTER $DEF
            ((COUNTER++))
        done
    fi
    cd  ../bin && ./$MANAGE $ARG > $LOGDIR$LOG
else
    echo  -e $RED'Service ['$PROCESS'] not started!'$DEF
    exit 1
fi

### Check, stopped or not ###
sleep 1
if [ $(pgrep $PROCESS) ]
then
    echo  -e $RED'Service ['$PROCESS'] not stopped!'$DEF
    exit 1
else
    echo  -e $BLUE'Service ['$PROCESS'] stopped!'$DEF
    exit 1
fi

exit 0